package com.netsitech.rcp.desktop.sample.context.generator;

import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import com.netsitech.rcp.desktop.sample.Activator;
import com.netsitech.rcp.desktop.sample.context.ContextFactory;
import com.netsitech.rcp.desktop.sample.context.ContextPackage;
import com.netsitech.rcp.framework.context.IFWKPerspectiveContext;
import com.netsitech.rcp.framework.context.generator.FWKBaseContextGenerator;
import com.netsitech.rcp.framework.context.generator.IFWKPerspectiveContextGenerator;

public class SampleContextGenerator extends FWKBaseContextGenerator implements IFWKPerspectiveContextGenerator {

	public SampleContextGenerator() {
	}

	@Override
	public EObject createDefaultContext() {
		return ContextFactory.eINSTANCE.createSampleContext();
	}

	@Override
	public String getBundleName() {
		return Activator.PLUGIN_ID;
	}

	@Override
	public EPackage getPackageINSTANCE() {
		return ContextPackage.eINSTANCE;
	}

	@Override
	public String getPackageNS_URI() {
		return ContextPackage.eNS_URI;
	}

	public IFWKPerspectiveContext generatePerspectiveContext() {
		return (IFWKPerspectiveContext) generateContext();
	}

	public IFWKPerspectiveContext generatePerspectiveContext(String context_dump) {
		return (IFWKPerspectiveContext) generateContext(context_dump);
	}

	public String generateXMI(IFWKPerspectiveContext ctx) {
		return toXMI(ctx);
	}
}
