package com.netsitech.rcp.desktop.sample.dialog;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.jface.window.IShellProvider;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.ui.views.properties.tabbed.TabbedPropertySheetWidgetFactory;

public class SampleDialog extends Dialog {
	public SampleDialog(IShellProvider parentShell) {
		super(parentShell);
	}

	public SampleDialog(Shell parentShell) {
		super(parentShell);
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		getShell().setText("Sample dialog");

		TabbedPropertySheetWidgetFactory factory = new TabbedPropertySheetWidgetFactory();

		Composite dialog = (Composite) super.createDialogArea(parent);

		GridLayout gl = new GridLayout(2, false);
		gl.marginBottom = gl.marginLeft = gl.marginRight = gl.marginTop = gl.horizontalSpacing = 10;
		dialog.setLayout(gl);

		Label label1 = new Label(dialog, SWT.NONE);
		label1.setText("Label 1");
		label1.setLayoutData(new GridData());

		Text text1 = factory.createText(dialog, "text 1", SWT.READ_ONLY);
		text1.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		Label label2 = new Label(dialog, SWT.NONE);
		label2.setText("Label 2");
		label2.setLayoutData(new GridData());

		Text text2 = factory.createText(dialog, "text 2", SWT.READ_ONLY);
		text2.setLayoutData(new GridData(GridData.FILL_HORIZONTAL));

		factory.paintBordersFor(dialog);

		return dialog;
	}
}
